<?php
/*
Plugin Name: QuickShop
Plugin URI: http://www.zackdesign.biz/wp-plugins/34
Description: Quick and easy shopping cart with widget!
Author: Isaac Rowntree
Version: 1.2.4.3
Author URI: http://zackdesign.biz

	Copyright (c) 2005, 2006 Isaac Rowntree (http://zackdesign.biz)
	QuickShop is released under the GNU General Public
	License (GPL) http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org).

Changelog:

1.2.4.3

- Disappeared the widget when empty

1.2.4.2

- Added option for Paypal email
- Fixed slight bug in admin form submit which made it impossible to have nothing submitted in currency (defaults to USD)

1.2.4.1

- Added more options for currency (e.g. formatting for money)

1.2.4

- Admin page for setting currency (works with Paypal widget)
- Removed style for colouring the widget - you should do these yourselves as it looks bad in some themes

1.2.3.1

- Fixed Problem with linking back to product
- Ensured that QuickShop Is Valid XHTML 1.0 Transitional

1.2.3

- Updated layout of widgets, added ability to link back to product item from the shopping cart
- Works out postage for you now

1.2.2

- Fixed changing product quantity on shopping cart widget
- Fixed Paypal form bug

1.2.1

- New TinyMCE Button

1.2

- Better Paypal integration. Now uses a new shopping cart widget instead!
- Quantity setting in sidebar widget
- Removal of extra Paypal tags to consolidate to just one tag.
- Added shipping by default

1.1

- Added product price
- Added tag for Paypal baskets

*/


session_start();

define('QUICKSHOP_URL_PATH', get_bloginfo('wpurl') . "/wp-content/plugins/quick-shop/");

if ($_POST['addcart'])
{
    if (!isset($_SESSION['cart']))
    {
        $_SESSION['cart'] = array();
    }
    $count = 1;
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if ($item['name'] == $_POST['product'])
        {
            $count +=  $item['quantity'];
            $item['quantity']++;
            unset($_SESSION['cart'][$key]);
            array_push($_SESSION['cart'], $item);
        }
    }
    if ($count == 1)
    {
        $product = array('name' => $_POST['product'], 'price' => $_POST['price'], 'quantity' => $count, 'shipping' => $_POST['shipping'], 'shipping2' => $_POST['shipping2'], 'postID' => $_POST['postID']);
        array_push($_SESSION['cart'], $product);
    }
    sort($_SESSION['cart']);
}
else if ($_POST['cquantity'])
{
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if (($item['name'] == $_POST['product']) && $_POST['quantity'])
        {
            $item['quantity'] = $_POST['quantity'];
            unset($_SESSION['cart'][$key]);
            array_push($_SESSION['cart'], $item);
        }
        else if (($item['name'] == $_POST['product']) && !$_POST['quantity'])
            unset($_SESSION['cart'][$key]);
    }
    sort($_SESSION['cart']);
}
else if ($_POST['delcart'])
{
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if ($item['name'] == $_POST['product'])
            unset($_SESSION['cart'][$key]);
    }
}


function widget_quickshop($args)
{
    if (cart_has_items())
    {
    
    $defaultSymbol = get_option('quickshop_symbol');
    $defaultDecimal = get_option('quickshop_decimal');
    if ($defaultCurrency && ($defaultCurrency != ''))
        $currency = $defaultCurrency;
    else
        $currency = 'USD';
    if ($defaultSymbol && ($defaultSymbol != ''))
        $symbol = $defaultSymbol;
    else
        $symbol = '$';
    if ($defaultDecimal && ($defaultDecimal != ''))
        $decimal = $defaultDecimal;
    else
        $decimal = '.';

    extract($args);
    
    echo $before_widget;
    echo '<div class="quickshopcart" style="padding: 5px;">';
    echo $before_title . 'Your Shopping Cart' . $after_title;
    
    echo '<br /><form method="post" action=""><table style="width: 100%;">';
    
    $count = 1;
    $total = 0;
    if ($_SESSION['cart'] && is_array($_SESSION['cart']))
    {
    
                echo '
        <tr>
        <th>Product</th><th>QTY</th><th>Price</th>
        </tr>';
    
    foreach ($_SESSION['cart'] as $item)
    {
        echo "     
        
        <tr><td style='overflow: hidden;'><a href='".get_permalink($item['postID'])."'>".$item['name']."</a></td>
        <td style='text-align: center'><form method=\"post\"  action=\"\" style='display: inline'>
        <input type='hidden' name='product' value='".$item['name']."' />
        
        <input type='hidden' name='cquantity' value='1' /><input type='text' name='quantity' value='".$item['quantity']."' size='1' /></form></td>
        <td style='text-align: center'>".$symbol.number_format(($item['price'] * $item['quantity']), 2, $decimal, ',')."</td>
        <td><form method=\"post\"  action=\"\">
        <input type='hidden' name='product' value='".$item['name']."' />
        <input type='hidden' name='delcart' value='1' />
        <input type='image' src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_remove.png' value='Remove' title='Remove' /></form></td></tr>
        ";
        $total += $item['price'] * $item['quantity'];
        $count += $item['quantity'];
        
        
        if ($item['shipping2'])
            $postage += (($item['quantity'] - 1) * $item['shipping2']) + $item['shipping'];
        else
            $postage += $item['quantity'] * $item['shipping'];
    }
    }
    
    $count--;
    
       if ($count)
       {
              echo "
       <tr><td></td><td></td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Subtotal: </td><td style='text-align: center'>".$symbol.number_format($total, 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Postage: </td><td style='text-align: center'>".$symbol.number_format($postage, 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Total: </td><td style='text-align: center'>".$symbol.number_format(($total + $postage), 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='4'>
       
       ";
          
          echo "<p  style='font-weight: bold'><a href='".get_bloginfo('wpurl')."/contact'>Proceed to Checkout <img src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_go.png' style='border: 0px;' title='Checkout' alt='Checkout' /></a></p>";
       }
       
       echo "
       
       </td></tr>
    </table><input type='hidden' value='$currency' name='currency'> <!-- This is here for your use with a custom form -->
    ";
    
    
    echo '</form></div>';
    
    echo $after_widget;
    
    }
}

function widget_quickshoppaypal($args)
{
    if (cart_has_items())
    {
    
    extract($args);
    
    $email = get_bloginfo('admin_email');
       
    $defaultCurrency = get_option('quickshop_currency');
    $defaultSymbol = get_option('quickshop_symbol');
    $defaultDecimal = get_option('quickshop_decimal');
    $defaultEmail = get_option('quickshop_pemail');
    if ($defaultCurrency && ($defaultCurrency != ''))
        $paypal_currency = $defaultCurrency;
    else
        $paypal_currency = 'USD';
    if ($defaultSymbol && ($defaultSymbol != ''))
        $paypal_symbol = $defaultSymbol;
    else
        $paypal_symbol = '$';
    if ($defaultDecimal && ($defaultDecimal != ''))
        $decimal = $defaultDecimal;
    else
        $decimal = '.';
    if ($defaultEmail && ($defaultEmail != ''))
        $email = $defaultEmail;
    
    echo $before_widget;
    echo '<div class="quickshopcart" style=" padding: 5px;">';
    echo $before_title . 'Your Shopping Cart' . $after_title;
    
    echo '<br /><table style="width: 100%;">';
    
    $count = 1;
    $total_items = 0;
    $total = 0;
    $form = '';
    if ($_SESSION['cart'] && is_array($_SESSION['cart']))
    {
    
        
                echo '
        <tr>
        <th>Product</th><th>QTY</th><th>Price</th>
        </tr>';
    
    foreach ($_SESSION['cart'] as $item)
    {
        echo "  
       
        
        <tr><td style='overflow: hidden;'><a href='".get_permalink($item['postID'])."'>".$item['name']."</a></td>
        <td style='text-align: center'><form method=\"post\"  action=\"\" style='display: inline'>
        <input type='hidden' name='product' value='".$item['name']."' />
        
        <input type='hidden' name='cquantity' value='1' /><input type='text' name='quantity' value='".$item['quantity']."' size='1' /></form></td>
        <td style='text-align: center'>".$paypal_symbol.number_format(($item['price'] * $item['quantity']), 2, $decimal, ',')."</td>
        <td><form method=\"post\"  action=\"\">
        <input type='hidden' name='product' value='".$item['name']."' />
        <input type='hidden' name='delcart' value='1' />
        <input type='image' src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_remove.png' value='Remove' title='Remove' /></form></td></tr>
        
        ";
        
        $form .= "
            <input type=\"hidden\" name=\"item_name_$count\" value=\"".$item['name']."\" />
            <input type=\"hidden\" name=\"amount_$count\" value='".$item['price']."' />
            <input type=\"hidden\" name=\"quantity_$count\" value=\"".$item['quantity']."\" />
            <input type=\"hidden\" name=\"shipping_$count\" value=\"".$item['shipping']."\" />
            <input type=\"hidden\" name=\"shipping2_$count\" value=\"".$item['shipping2']."\" />
        ";
        
        $total += $item['price'] * $item['quantity'];
        $count++;
        $total_items +=  $item['quantity'];
        if ($item['shipping2'])
            $postage += (($item['quantity'] - 1) * $item['shipping2']) + $item['shipping'];
        else
            $postage += $item['quantity'] * $item['shipping'];
    }
    }
    
        $count--;
    
       if ($count)
       {
              echo "
       <tr><td></td><td></td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Subtotal: </td><td style='text-align: center'>".$paypal_symbol.number_format($total, 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Postage: </td><td style='text-align: center'>".$paypal_symbol.number_format($postage, 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='2' style='font-weight: bold; text-align: right;'>Total: </td><td style='text-align: center'>".$paypal_symbol.number_format(($total + $postage), 2, $decimal, ',')."</td><td></td></tr>
       <tr><td colspan='4'>
       

       
       <form action=\"https://www.paypal.com/us/cgi-bin/webscr\" method=\"post\">$form";
    if ($count)
        echo '<input type="image" src="'.get_bloginfo('wpurl').'/wp-content/plugins/quick-shop/images/btn_xpressCheckout.gif" name="submit" alt="Make payments with PayPal - it\'s fast, free and secure!" />';
    
    echo '
    <input type="hidden" name="business" value="'.$email.'" />
    <input type="hidden" name="currency_code" value="'.$paypal_currency.'" />
    <input type="hidden" name="cmd" value="_cart" />
    <input type="hidden" name="upload" value="1" />
    </form>';
          
          
       }
       
       echo "
       
       </td></tr>
    </table></div>
    ";
    
    echo $after_widget;

    }
}

function quickshop_widgets()
{

    register_sidebar_widget('QuickShop', 'widget_quickshop');
    
    register_sidebar_widget('QuickShop Paypal', 'widget_quickshoppaypal');

}

function quickshop_button_post($content)
{
    $forms = str_replace('[quickshop:',
    
    '<object><form method="post"  action=""  style="display:inline">
    <input type="submit" value="Add to Cart" />
    <input type="hidden" name="product" value="',
    
    $content);
    
    $forms = str_replace(':price:',
    
    '" /><input type="hidden" name="price" value="',
    
    $forms);
    
    $forms = str_replace(':shipping:',
    
    '" /><input type="hidden" name="shipping" value="',
    
    $forms);
    
    $forms = str_replace(':shipping2:',
    
    '" /><input type="hidden" name="shipping2" value="',
    
    $forms);
    global $post;
    $forms = str_replace(':end]',
    
    '" /><input type="hidden" name="addcart" value="1" /><input type="hidden" name="postID" value="'.$post->ID.'" /></form></object>',
    
    $forms);
    
    
    return $forms;
}


function quickshop_options()
{

     echo '<div class="wrap"><h2>QuickShop Options</h2>';
     if ($_REQUEST['submitform']) {
          update_quickshop_options();
     }
     print_quickshop_form();
     echo '</div>';

}

function update_quickshop_options() {
     $updated = false;
     if ($_REQUEST['currency'] || $_REQUEST['symbol'] || $_REQUEST['decimal'] || $_REQUEST['pemail']) {
          update_option('quickshop_currency', $_REQUEST['currency']);
          update_option('quickshop_symbol', $_REQUEST['symbol']);
          update_option('quickshop_decimal', $_REQUEST['decimal']);
          update_option('quickshop_pemail', $_REQUEST['pemail']);
          $updated = true;
     }

     if ($updated) {
           echo '<div id="message" class="updated fade">';
           echo '<p>Options Updated</p>';
           echo '</div>';
      } else {
           echo '<div id="message" class="error fade">';
           echo '<p>Unable to update options</p>';
           echo '</div>';
      }
}

function print_quickshop_form () {
    $defaultCurrency = get_option('quickshop_currency');
    $defaultSymbol = get_option('quickshop_symbol');
    $defaultDecimal = get_option('quickshop_decimal');
    $defaultEmail = get_option('quickshop_pemail');

      echo '
 <form method="post">
       <label>Paypal Email:
      <input type="text" name="pemail" value="'.$defaultEmail.'" />
      </label>
      <br /><br />
      <label>Currency (e.g. AUD, USD):
      <input type="text" name="currency" value="'.$defaultCurrency.'" />
      </label>
      <br /><br />
      <label>Currency Sybmol (e.g. $, &#163;):
      <input type="text" name="symbol" value="'.$defaultSymbol.'" />
      </label>
      <br /><br />
      <label>Decimal Sign (e.g. a period or a comma):
      <input type="text" name="decimal" value="'.$defaultDecimal.'" />
      </label>
      <br /><br />
      <input type="submit" name="submitform" value="Submit" />
 </form>
 ';
}

function quickshop_options_page () {
     add_options_page(
                      'QuickShop',         //Title
                      'QuickShop',         //Sub-menu title
                      'manage_options', //Security
                      __FILE__,         //File to open
                      'quickshop_options'  //Function to call
                     );  
}

add_action('plugins_loaded', 'quickshop_widgets');

add_action('admin_menu','quickshop_options_page');

add_filter('the_content', 'quickshop_button_post');


function cart_has_items()
{
    if (!size_of($_SESSION['cart']))
        return 0;
    else
        return 1;
}


//#################################################################
// TinyMCE Button Integration

// Load the Script for the Button
function insert_quickshop_script() {	
 
 	//TODO: Do with WP2.1 Script Loader
 	// Thanks for this idea to www.jovelstefan.de
 	
	echo "\n"."
	<script type='text/javascript'> 
		function quickshop_buttonscript()	{ 
		if(window.tinyMCE) {

			var template = new Array();
	
			template['file'] = '".QUICKSHOP_URL_PATH."quickshopbutton.php';
			
			template['width'] = 360;
			template['height'] = 210;
	
			args = {
				resizable : 'no',
				scrollbars : 'no',
				inline : 'yes'
			};
	
			tinyMCE.openWindow(template, args);
			return true;
		} 
	} 
	</script>"; 
	return;
}

function quickshop_addbuttons() {
 
	global $wp_db_version;

	// Don't bother doing this stuff if the current user lacks permissions
	if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;
	 
	// Add only in Rich Editor mode
	if ( get_user_option('rich_editing') == 'true') {
	 
	// add the button for wp21 in a new way
		add_filter("mce_plugins", "quickshop_button_plugin", 5);
		add_filter('mce_buttons', 'quickshop_button', 5);
		add_action('tinymce_before_init','quickshop_button_script');
		}
}

// used to insert button in wordpress 2.1x editor
function quickshop_button($buttons) {

	array_push($buttons, "separator", "QuickShop");
	return $buttons;

}

// Tell TinyMCE that there is a plugin (wp2.1)
function quickshop_button_plugin($plugins) {    

	array_push($plugins, "-QuickShop");    
	return $plugins;
}

// Load the TinyMCE plugin : editor_plugin.js (wp2.1)
function quickshop_button_script() {	
 
 	$pluginURL =  QUICKSHOP_URL_PATH.'js/';
	echo 'tinyMCE.loadPlugin("QuickShop", "'.$pluginURL.'");' . "\n"; 
	return;
}

// init process for button control
add_action('init', 'quickshop_addbuttons');
add_action('edit_page_form', 'insert_quickshop_script');
add_action('edit_form_advanced', 'insert_quickshop_script');

//#################################################################


?>
